/*
   Project: ThreadTest

   Copyright (C) 2005 Free Software Foundation

   Author: Guenther Noack,,,

   Created: 2005-10-10 10:40:23 +0200 by guenther

   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA.
*/

#include "ThreadTestController.h"

@implementation ThreadTestController

-init
{
  self = [super init];
  
  if (self != nil) {
    NSLog(@"ThreadTestController initializing...");
    lock = [[NSLock alloc] init];
  }
  
  return self;
}



-(void) changeIcon: (id) sender
{
  static currentIcon = 0;
  NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
  
  [lock lock];
  
  currentIcon = (currentIcon+1)%2;
  
  [NSApp setApplicationIconImage: 
	   [NSImage
	     imageNamed: (currentIcon?@"page_landscape":@"page_portrait")
	    ]];
  [NSApp updateWindows];
  
  [lock unlock];
  
  [pool release];
}


-(void) changeIconThreaded: (id) sender
{
  [NSThread detachNewThreadSelector: @selector(changeIcon:)
	    toTarget: self
	    withObject: nil];
}

@end
